﻿init python:
    import random
    import time
    random.seed(time.clock())



    def is_black(image, x, y):
        # img_size = renpy.image_size(image)
        img = renpy.load_surface(image)
        color = img.get_at((x, y))
        if color[0] == 0:
            return True
        return False

    class map_click:
        def __init__(self, name, pos = (0,0), action = None, image = "map_marker"):
            self.name = name
            self.pos = pos
            self.action = action
            self.image = image

    class map_class:
        def __init__(self, name, clicks, spawns, tiles):
            self.name = name
            self.clicks = clicks
            self.spawns = spawns
            self.water = "images/map_water.png"

        def spawn(self):
            x = random.randint(60, 1860)
            y = random.randint(60, 1020)
            if is_black(self.water, x, y):
                s = random.choice(self.spawns)
                spawn = map_click(s.name, (x,y), s.action, s.image)
                self.clicks.append(spawn)
                return
            
            self.spawn()



default booty_bay = map_click("Booty Bay", (826,612), Jump("booty_bay"))
default the_white_beach = map_click("The white beach", (1411,428), Jump("the_white_beach"))
default scarlet_rocks = map_click("The scarlet rocks", (1117,679), Jump("scarlet_rocks"))

default the_corridor = map_class(
    "The corridor",
    [
        booty_bay,
        the_white_beach,
        scarlet_rocks,
    ],
    [
        map_click(name = "Spanish cargo", action = Jump("attacking_spanish_cargo"), image = "spanish_cargo"),
        map_click(name = "Wrecked ship", action = Jump("rescue_mission"), image = "wrecked_ship"),
        map_click(name = "Red boat", action = Jump("red_mystery"), image = "red_boat"),
    ],[]
)
screen map_screen(g = the_corridor):
    modal True
    style_prefix "map"

    for i in g.clicks:
        button:
            xysize 100,100 background None
            pos i.pos align .5,.5
            add i.image align .5,.5
            action i.action
        button:
            pos i.pos background None
            align .5,.5 yoffset 40
            frame:
                at nameplate_sway(random.random())
                background Frame("map_title_plate", 20,0)
                padding 20,0 ysize 28
                text i.name color "#260a02" size 22
            action i.action

    button:
        text "test"
        action Function(g.spawn)
    
transform nameplate_sway(delay):
    subpixel True
    alpha 0
    pause delay
    ease 1 alpha 1
    block:
        ease 2 yoffset 10
        ease 2 yoffset 0
        repeat

define redteeth = Character("Cpt. Red teeth")
define crew = Character("Crew")
define me = Character("Me")

label intro:
    redteeth "Boy I'm tired of the constant scurvy."
    redteeth "I want to retire to the white sand beach."
    redteeth "Lay on the sand and sip those fruity drinks."
    redteeth "The ones with an umbrella, and slices of lime."
    me "Do it capitan."
    redteeth "What about my ship? My crew?"
    me "I'll keep your ship sailing capitan."
    redteeth "Hmmm..."
    redteeth "You've proven yourself trustworthy."
    redteeth "If you bring me my share of the booty, I'll let you run my ship."
    me "Aye capitan."
    redteeth "We have a deal then."
    redteeth "TURN TO PORT! WE'RE SAILING TO THE WHITE SANDS."
    crew "AYE AYE CAPITAN!"

label map:
    scene map_background with dissolve
    call screen map_screen


label booty_bay:
    scene bg booty_bay
    "Herr's some gossip."
    $ the_corridor.spawn()
    jump map

label the_white_beach:
    scene bg the_white_beach
    "Capitan smiles."
    jump map

label scarlet_rocks:
    scene bg scarlet_rocks
    "Something else."
    jump map


label attacking_spanish_cargo:
    scene bg attacking_spanish_cargo
    "A fight will happen here"
    jump map

label rescue_mission:
    scene bg rescue_mission
    "Top off your crew."
    jump map

label red_mystery:
    scene bg red_mystery
    "Top off your crew."
    jump map